// Dragon.java

import ch.aplu.turtle.*;

public class Dragon
{
  private Turtle t = new Turtle(false);
  final private int nbGenerations = 17;

  public Dragon()
  {
    t.enableRepaint(false);
    t.right(90);
    t.setPos(-100, 100);
    figure(250, nbGenerations, true);
    t.repaint();
  }

  private void figure(double length, int n, boolean inverse)
  {
    if (n == 0)
      t.forward(length);
    else
    {
      int alpha = 45;
      if (inverse)
      {
        alpha = -alpha;
        inverse = !inverse;
      }
      t.left(alpha);
      figure(length / Math.sqrt(2), n - 1, !inverse);
      t.right(2 * alpha);
      figure(length / Math.sqrt(2), n - 1, inverse);
      t.left(alpha);
    }
  }

  public static void main(String args[])
  {
    new Dragon();
  }
}
