// LazyTurtle.java

import ch.aplu.turtle.*;

public class LazyTurtle extends Turtle
{
  // J2SE V5 Version:
  public LazyTurtle forward(double distance)
  {
    left(30);
    super.forward(0.577350 * distance);
    right(60);
    super.forward(0.577350 * distance);
    left(30);
    return this;
  }

  // Pre-J2SE V5 Version:
  /*
  public Turtle forward(double distance)
  {
    left(30);
    super.forward(0.577350 * distance);
    right(60);
    super.forward(0.577350 * distance);
    left(30);
    return this;
  }
  */

  public LazyTurtle dance()
  {
    for (int i = 0; i < 10; i++)
      left(36);
    return this;
  }
}


/* Compile time error with Pre-J2SE-5:

forward(double) in LeisureTurtle kann forward(double)
in ch.aplu.turtle.Turtle nicht ueberschreiben; es wurde versucht,
inkompatible Rueckgabetypen zu verwenden

*/
