// Tufam.java
// Verfolgungskurven

import ch.aplu.turtle.*;
import java.awt.Color;

// ----------- Class TurtleChild -----------------
class TurtleChild extends Turtle
{
  TurtleChild(TurtleMother mother) // Constructor
  {
    super(mother);
    myMother = mother;
  }

  public void turnTo(double x, double y)
  {
    setHeading(towards(x, y));
  }

  public void follow(double x, double y)
  {
    turnTo(x, y);
    if (distance(x, y) > 0)
      forward(distance(x, y) / 15);
  }

  public void follow(TurtleChild t)
  {
    follow(t.getX(), t.getY());
  }

  public void followMother()
  {
    follow(myMother.getX(), myMother.getY());
  }

  private TurtleMother myMother;
}

// ----------- Class TurtleMother ----------------
class TurtleMother extends Turtle
{
  private int numChildren = 0;
  private final int maxNumChildren = 2;
  private TurtleChild[] children = new TurtleChild[10];
  private int steps = 0;

  TurtleMother(Color c) // Constructor
  {
    super(c);
    numChildren = 0;
  }

  public void createChild()
  {
    children[numChildren++] = new TurtleChild(this);
  }

  public void walk(int step)
  {
    int i;
    fd(step);
    if (numChildren > 0)
    {
      children[0].followMother();
      for (i = 1; i < numChildren; i++)
        children[i].follow(children[i - 1]);
    }
  }

  public void walkx(int step)
  {
    walk(step);
    steps += step;
    if (numChildren < maxNumChildren && steps > 40)
    {
      createChild();
      steps = 0;
    }
  }

}

// ----------- Application class -----------------
public class Tufam
{
  public static void main(String[] args)
  {
    TurtleMother laura = new TurtleMother(Color.red);
    laura.setPos(-100, 0);
    while (true)
    {
      laura.walkx(4);
      laura.right(2);
    }
  }
}
