// ButtonEx2.java

import ch.aplu.util.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;

class OkBtn_ActionAdapter implements ActionListener
{
  private ButtonEx2 app;

  OkBtn_ActionAdapter(ButtonEx2 app)
  {
    this.app = app;
  }

  public void actionPerformed(ActionEvent evt)
  {
    app.okButton_actionPerformed(evt);
  }
}

class QuitBtn_ActionAdapter implements ActionListener
{
  private ButtonEx2 app;

  QuitBtn_ActionAdapter(ButtonEx2 app)
  {
    this.app = app;
  }

  public void actionPerformed(ActionEvent evt)
  {
    app.quitButton_actionPerformed(evt);
  }
}

public class ButtonEx2
{
  private GPanel dialog = new GPanel("Funktion y = sin(x)/x",
                                     false);
  private GPanel graph = new GPanel("Graph");

  private JLabel labelMin = new JLabel("xmin: ");
  private JTextField textFieldMin = new JTextField(10);
  private JLabel labelMax = new JLabel("xmax: ");
  private JTextField textFieldMax = new JTextField(10);

  private JTextArea textAreaOut = new JTextArea(27, 40);
  private JScrollPane scrollPaneOut =
    new JScrollPane(
      textAreaOut, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
      JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
  private JButton okButton = new JButton("Fhre aus");
  private JButton quitButton = new JButton("Ende");

  public ButtonEx2()
  {
    dialog.add(labelMin);
    dialog.add(textFieldMin);
    dialog.add(labelMax);
    dialog.add(textFieldMax);
    dialog.add(okButton);
    dialog.add(quitButton);
    dialog.add(scrollPaneOut);

    textFieldMin.setText("-100");
    textFieldMax.setText("100");
    textAreaOut.setEditable(false);

    okButton.addActionListener(
      new OkBtn_ActionAdapter(this));
    quitButton.addActionListener(
      new QuitBtn_ActionAdapter(this));

    dialog.visible(true);
  }

  void okButton_actionPerformed(ActionEvent evt)
  {
    DecimalFormat df = new DecimalFormat("#0.000");
    String start = textFieldMin.getText().trim();
    double xMin = Double.parseDouble(start);
    String end = textFieldMax.getText().trim();
    double xMax = Double.parseDouble(end);
    graph.window(xMin, xMax, -0.3, 1);
    double step = (xMax - xMin) / 500;

    textAreaOut.setText("");
    graph.clear();
    for (double x = xMin; x <= xMax; x += step)
    {
      if (Math.abs(x) > 10E-6)
      {
        double y = Math.sin(x) / x;
        textAreaOut.append("x = " +
                           Console.pad(df.format(x), 10, 3) +
                           "\t\ty = " +
                           Console.pad(df.format(y), 10, 3) +
                           "\n");
        if (x == xMin)
        {
          graph.move(x, y);
        }
        else
        {
          graph.draw(x, y);
        }
      }
    }
  }

  void quitButton_actionPerformed(ActionEvent evt)
  {
    System.exit(0);;
  }

  public static void main(String[] args)
  {
    new ButtonEx2();
  }
}
