// MenuEx2.java

import javax.swing.*;
import java.awt.Color;
import java.awt.event.*;
import ch.aplu.turtle.*;

public class MenuEx2 implements ActionListener
{
  interface State
  {
    int IDLE = 0;
    int RUNNING = 1;
    int EXITING = 2;
  }

  private Turtle john = new Turtle(setMenu(), Color.red);
  private JMenuItem runItem, stopItem, exitItem;
  private int state = State.IDLE;

  public MenuEx2()
  {
    while (state != State.EXITING)
    {
      Turtle.sleep(1);
      while (state == State.RUNNING)
        john.fd(10).lt(10);
    }
    System.exit(0);
  }

  private JMenuBar setMenu()
  {
    exitItem = new JMenuItem("Exit");
    exitItem.addActionListener(this);

    runItem = new JMenuItem("Run");
    runItem.addActionListener(this);

    stopItem = new JMenuItem("Stop");
    stopItem.addActionListener(this);

    JMenuBar menuBar = new JMenuBar();
    menuBar.add(exitItem);
    menuBar.add(runItem);
    menuBar.add(stopItem);
    return menuBar;
  }

  public void actionPerformed(ActionEvent e)
  {
    if (e.getSource() == runItem)
      state = State.RUNNING;
    if (e.getSource() == stopItem)
      state = State.IDLE;
    if (e.getSource() == exitItem)
      state = State.EXITING;
  }

  public static void main(String[] args)
  {
    new MenuEx2();
  }
}
