// PixelColor.java
// Return color of clicked pixel

import ch.aplu.util.*;
import java.awt.Color;
import java.awt.event.*;

public class PixelColor extends GPanel
{
  public PixelColor()
  {
    title("Click to get pixel color");
    window(380, 780, 0, 1);
    addMouseListener(new MouseAdapter()
    {
      public void mousePressed(MouseEvent evt)
      {
        Color c = getPixelColor(toWindow(evt.getPoint()));
        title(c.toString().substring(9));
      }
    });

    for (int i = 380; i <= 780; i++)
    {
      color(wavelengthToRGB(i));
      fillRectangle(i, 0, i + 1.3, 1);
    }
  }

  private Color wavelengthToRGB(int wavelength)
  // Adapted from www.isc.tamu.edu/~astro/color.html
  // wavelength in nm, 380 .. 780
  {
    double blue, green, red, factor;

    if (wavelength >= 380 && wavelength <= 439)
    {
      red = 0.0;
      green = 0.0;
      blue = (wavelength - 380) / (440.0 - 380);
    }
    else
      if (wavelength >= 440 && wavelength <= 489)
      {
        red = 0.0;
        green = (wavelength - 440) / (490.0 - 440);
        blue = 1.0;
      }
      else
        if (wavelength >= 490 && wavelength <= 509)
        {
          red = 0.0;
          green = 1.0;
          blue = -(wavelength - 510) / (510.0 - 490);
        }
        else
          if (wavelength >= 510 && wavelength <= 579)
          {
            red = (wavelength - 510) / (580.0 - 510);
            green = 1.0;
            blue = 0.0;
          }
          else
            if (wavelength >= 580 && wavelength <= 644)
            {
              red = 1.0;
              green = -(wavelength - 645) / (645.0 - 580);
              blue = 0.0;
            }
            else
              if (wavelength >= 645 && wavelength <= 780)
              {
                red = -(wavelength - 780) / (780.0 - 645);
                green = 0.0;
                blue = 0.0;
              }
              else
              {
                red = 0.0;
                green = 0.0;
                blue = 0.0;
              }

    return new Color((float)red, (float)green, (float)blue);
  }

  public static void main(String[] args)
  {
    new PixelColor();
  }
}
