// TurtlePet.java

package turtlepet;

import ch.aplu.turtle.*;

public class TurtlePet extends Turtle
{
  private BorderListener borderListener;

  public void addBorderListener(BorderListener bl)
  {
    borderListener = bl;
  }

  public Turtle forward(double s)
  {
    boolean isCrossed = false;

    if (getX() < -200)
    {
      setX(-200);
      borderListener.leftBorderCrossed(getY(), heading());
      isCrossed = true;
    }
    if (getX() > 200)
    {
      setX(200);
      borderListener.rightBorderCrossed(getY(), heading());
      isCrossed = true;
    }
    if (getY() < -200)
    {
      setY(-200);
      borderListener.bottomBorderCrossed(getX(), heading());
      isCrossed = true;
    }
    if (getY() > 200)
    {
      setY(200);
      borderListener.topBorderCrossed(getX(), heading());
      isCrossed = true;
    }

    if (!isCrossed)
    {
      final int range = 50;
      double dist1 = distance(0, 0);
      super.forward(s);
      double dist2 = distance(0, 0);
      if (dist1 <= range && dist2 > range)
        borderListener.rangeExited(getX(), getY(), heading());
      if (dist1 >= range && dist2 < range)
        borderListener.rangeEntered(getX(), getY(),
                                    heading());
    }

    return this;
  }
}
