// SimEx3.java
// Schiefer Wurf mit Luftwiderstand
// Halbschrittbeginn

import ch.aplu.util.*;
import static java.lang.Math.*;

class SimEx3 extends GPanel
{
  SimEx3()
  {

    final double g = 9.81;         // Erdbeschleunigung  in m/s^2
    final double d = 0.1;          // Zeitschritt in s
    final double m = 8.8e-3;       // Kugelmasse in kg
    final double rho = 1.06e-3;    // Reibungskoeffizient in Ns^2/m^2
    final double x0 = 0;           // Anfangs-x-Koordinate in m
    final double y0 = 0;           // Anfangs-y-Koordinate in m
    final double v0 = 100;         // Abschussschnelligkeit in m/s
    double alpha = 50;             // Abschusswinkel in Grad
    alpha = alpha / 180 * 3.14159; // in Bogenmass

    double t = 0;
    double x = x0, y = y0;
    double vx = v0 * cos(alpha);
    double vy = v0 * sin(alpha);

    double ax, ay, fx, fy;

    title(
      "Schiefer Wurf mit Luftwiderstand. Reibung prop v^2");
    window(-5, 25, -15, 15);

    // Koordinatensystem
    line(-5, 0, 25, 0);  // x-Achse
    line(0, -15, 0, 15); // y-Achse

    move(x, y);
    do
    {
      // Kraftkoordinaten 	
      fx = -rho * sqrt(vx * vx + vy * vy) * vx; 
      fy = -m * g - rho * sqrt(vx * vx + vy * vy) * vy;

      // Beschleunigungskoordinaten
      ax = fx / m; 
      ay = fy / m;

      // Geschwindigkeitskoordinaten
      if (t == 0) // Halbschrittbeginn
      {
        vx = vx + ax * d / 2; 
        vy = vy + ay * d / 2;
      }
      else
      {
        vx = vx + ax * d;
        vy = vy + ay * d;
      }
      
      // Ortskoordinaten
      x = x + vx * d; 
      y = y + vy * d;

      // Zeit
      t = t + d; 

      // Plot
      draw(x, y);
    }
    while (t < 10);
  }


  public static void main(String[] args)
  {
    new SimEx3();
  }
}
