// WindowEx4.java

import ch.aplu.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;

public class WindowEx4 extends JPanel
{
  private GWindow w = new GWindow();

  public WindowEx4()
  {
    w.setWinSize(401, 401);
    w.showComponent(this);

    GeneralPath square = createSquare(100);
    drawFigure(square);

    translateFigure(square, 200, 200);
    drawFigure(square);

    GeneralPath triangle = createTriangle(50);
    drawFigure(triangle);
    translateFigure(triangle, 200, 200);
    drawFigure(triangle);

    rotateFigure(triangle, Math.PI / 2, 200, 200);
    drawFigure(triangle);

    scaleFigure(square, 1.1, 1.3);
    drawFigure(square);

    square = createSquare(100);
    shearFigure(square, 2, 1);
    drawFigure(square);
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    BufferedImage bi = w.getBufferedImage();
    Graphics2D g2D = (Graphics2D)g;
    g2D.drawImage(bi, w.getAffineScale(), this);
  }

  GeneralPath createSquare(int size)
  {
    GeneralPath gp = new GeneralPath();
    gp.moveTo(0, 0);
    gp.lineTo(size, 0);
    gp.lineTo(size, size);
    gp.lineTo(0, size);
    gp.closePath();
    return gp;
  }

  GeneralPath createTriangle(int size)
  {
    GeneralPath gp = new GeneralPath();
    gp.moveTo(0, 0);
    gp.lineTo(size, 0);
    gp.lineTo(size / 2, size);
    gp.closePath();
    return gp;
  }

  void drawFigure(GeneralPath gp)
  {
    Graphics2D g2D = w.getOffG2D();
    g2D.draw(gp);
    repaint();
  }

  void translateFigure(GeneralPath gp, int dx, int dy)
  {
    AffineTransform t = new AffineTransform();
    t.translate(dx, dy);
    gp.transform(t);
  }

  void rotateFigure(GeneralPath gp, double angle,
                    int xCenter, int yCenter)
  {
    AffineTransform t = new AffineTransform();
    t.rotate(angle, xCenter, yCenter);
    gp.transform(t);
  }

  void scaleFigure(GeneralPath gp, double xScale,
                   double yScale)
  {
    AffineTransform t = new AffineTransform();
    t.scale(xScale, yScale);
    gp.transform(t);
  }

  void shearFigure(GeneralPath gp, double xShear,
                   double yShear)
  {
    AffineTransform t = new AffineTransform();
    t.shear(xShear, yShear);
    gp.transform(t);
  }

  public static void main(String[] args)
  {
    new WindowEx4();
  }
}
