// PrintEx2.java

import ch.aplu.util.*;
import java.awt.geom.*;
import javax.swing.JOptionPane;

class Wave
{
  final private int nbCrests = 50;
  private double wavelength;

  Wave(double wavelength)
  {
    this.wavelength = wavelength;
  }

  void showAt(GPanel p, Point2D.Double center)
  {
    p.move(center);
    for (int i = 1; i <= nbCrests; i++)
      p.circle(i * wavelength);
  }
}

public class PrintEx2 implements GPrintable
{
  // Use special coordinates to avoid rounding errors
  private GPanel p = new GPanel(0, 500, 0, 500);

  public PrintEx2()
  {
    draw();
    if (p.print(this))
      JOptionPane.showMessageDialog(
        null, "Drawing sent to printer");

    System.exit(0);
  }

  public void draw()
  {
    Wave wave = new Wave(3);
    wave.showAt(p, new Point2D.Double(250, 250));
    wave.showAt(p, new Point2D.Double(257, 250));
  }

  public static void main(String[] args)
  {
    new PrintEx2();
  }
}
