// RandomEx1.java

import javax.swing.*;
import java.io.*;

public class RandomEx1
{
  private final static int DOUBLE_SIZE = 8; // in bytes

  public RandomEx1()
  {
    String msg = "";
    RandomAccessFile raf = null;
    double[] a = new double[10];

    try
    {
      JFileChooser chooser = new JFileChooser();
      if (chooser.showSaveDialog(null)
              == JFileChooser.CANCEL_OPTION)
        System.exit(1);

      File file =
        new File(chooser.getCurrentDirectory(),
                 chooser.getSelectedFile().getName());

      // Delete old file
      if (file.isFile())
        file.delete();

      // Create and write to file
      raf = new RandomAccessFile(file, "rw");
      for (int i = 0; i < 10; i++)
        raf.writeDouble(Math.sqrt(i));
      raf.close();
      raf = null;
      JOptionPane.showMessageDialog(
        null,
        "Datei\n" + file.getPath() +
        "\nerfolgreich geschrieben");

      // Modify a record
      int nb = 3; // record number
      raf = new RandomAccessFile(file, "rw");

      // At start of 4th record
      long filePointer = nb * DOUBLE_SIZE;
      raf.seek(filePointer);
      raf.writeDouble(-1.23456789);
      raf.close();
      raf = null;

      // Read all records from file
      raf = new RandomAccessFile(file, "r");
      for (int i = 0; i < raf.length() / DOUBLE_SIZE; i++)
        a[i] = raf.readDouble();
    }
    catch (Exception ex)
    {
      msg = "Fatal error in file operations";
    }

    try
    {
      if (raf != null)
        raf.close();
    }
    catch (IOException ex) {}

    if (msg.equals("")) // File operations successfull
      for (int i = 0; i < 10; i++)
        msg = msg + Double.toString(a[i]) + "\n";
    JOptionPane.showMessageDialog(null, msg);
    System.exit(0);
  }

  public static void main(String[] args)
  {
    new RandomEx1();
  }
}
