// GFrame.java

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class GFrame extends JFrame
{
  private final int WIDTH = 500;
  private final int HEIGHT = 500;
  private final Color BACKGROUND_COLOR = Color.white;
  private Container contentPane;
  private Graphics2D offG2D;
  private BufferedImage bi;
  private JComponent component;

  public GFrame()
  {
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    contentPane = (JPanel)getContentPane();
    setTitle("Net");
    bi = new BufferedImage(WIDTH, HEIGHT,
                           BufferedImage.TYPE_INT_RGB);
    offG2D = bi.createGraphics();
    clearBuf();
  }

  public void showComponent(JComponent jc)
  {
    component = jc;
    component.setPreferredSize(new Dimension(WIDTH, HEIGHT));
    contentPane.add(component, BorderLayout.CENTER);
    pack();
    setVisible(true);
  }

  public Graphics2D getOffG2D()
  {
    return offG2D;
  }

  public BufferedImage getBufferedImage()
  {
    return bi;
  }

  public void clearBuf()
  {
    offG2D.setColor(BACKGROUND_COLOR);
    offG2D.fill(new Rectangle.Double(0, 0, WIDTH, HEIGHT));
  }
}
