// Node.java

import java.awt.*;

public class Node extends Point implements Item
{
  final private int R = 10;

  public Node(Point pt)
  {
    super(pt.x, pt.y);
  }

  public Node(int x, int y)
  {
    super(x, y);
  }

  public void draw(Graphics2D g2D)
  {
    g2D.setColor(Color.red);
    g2D.fillOval(x - R, y - R, 2 * R, 2 * R);
  }

  public boolean isHot(Point pt)
  {
    return (pt.x > x - R &&
            pt.x < x + R &&
            pt.y > y - R &&
            pt.y < y + R);
  }

  public boolean isHot(int x, int y)
  {
    return isHot(new Point(x, y));
  }
}
