// CtorEx11.java

import ch.aplu.util.*;

class Fraction
{
  private int numerator;
  private int denominator;

  public static Fraction create(int numerator,
                                int denominator)
  {
    if (denominator == 0)
      return null;
    else
      return new Fraction(numerator, denominator);
  }

  private Fraction(int numerator, int denominator)
  {
    this.numerator = numerator;
    this.denominator = denominator;
  }

  public String toString()
  {
    if (denominator == 0)
      return "NaF"; // Not a Fraction
    return Integer.toString(numerator) + "/" +
           Integer.toString(denominator);
  }
}

public class CtorEx11 extends Console
{
  public CtorEx11()
  {
    while (true)
    {
      Fraction p = readFraction();
      if (p != null)
        println("Ok. Bruch p = " + p);
      else
        println("Kein Bruch");
    }
  }

  public Fraction readFraction()
  {
    print("Zaehler: ");
    int num = readInt();
    print("Nenner: ");
    int denom = readInt();
    return Fraction.create(num, denom);
  }

  public static void main(String[] args)
  {
    new CtorEx11();
  }
}
