// GuiEx3.java

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class GuiEx3 extends JFrame
{
  private class GraphPane extends JPanel
  {
    public void paintComponent(Graphics g)
    {
      super.paintComponent(g);
      drawBall(g, Color.red);
    }
  }

  private JPanel contentPane;
  private JPanel navigationPane = new JPanel();
  private JPanel graphPane = new GraphPane();
  private BorderLayout borderLayout = new BorderLayout();
  private JRadioButton upBtn = new JRadioButton("up", true);
  private JRadioButton dwnBtn = new JRadioButton("down");
  private ButtonGroup buttonGroup = new ButtonGroup();
  private JButton moveBtn = new JButton("Move");
  private int choice = 1;
  private int yImg = 75;

  public GuiEx3()
  {
    super("Move Ball");
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    init();
    pack();
    setResizable(false);
    setVisible(true);
  }

  private void init()
  {
    contentPane = (JPanel)getContentPane();
    graphPane.setPreferredSize(new Dimension(100, 200));
    navigationPane.setPreferredSize(new Dimension(100, 200));

    graphPane.setBackground(Color.white);
    navigationPane.setLayout(new BoxLayout(navigationPane,
                                           BoxLayout.Y_AXIS));

    contentPane.add(navigationPane, BorderLayout.WEST);
    contentPane.add(graphPane, BorderLayout.CENTER);

    buttonGroup.add(upBtn);
    buttonGroup.add(dwnBtn);
    navigationPane.add(upBtn);
    navigationPane.add(dwnBtn);
    navigationPane.add(moveBtn);

    upBtn.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        choice = 1;
      }
    });

    dwnBtn.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        choice = 2;
      }
    });

    moveBtn.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        // Erase
        Graphics g = graphPane.getGraphics();
        drawBall(g, Color.white);

        // Draw at new position
        if (choice == 1)
          yImg -= 10;
        if (choice == 2)
          yImg += 10;
        graphPane.repaint();
      }
    });
  }

  private void drawBall(Graphics g, Color c)
  {
    g.setColor(c);
    g.fillOval(25, yImg, 50, 50);
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new GuiEx3();
      }
    });
  }
}
