// GuiEx6.java

import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;

public class GuiEx6 extends JFrame implements
    HyperlinkListener
{
  private JEditorPane htmlPane;
  private JScrollPane jScrollPane;
  private String urlHome = "http://www.google.ch";

  public GuiEx6()
  {
    super("Simple HTML-Browser");
    setDefaultCloseOperation(WindowConstants.
                             EXIT_ON_CLOSE);
    init();
    pack();
    setVisible(true);
  }

  private void init()
  {
    try
    {
      htmlPane = new JEditorPane(urlHome);
    }
    catch (IOException ex)
    {
      System.out.println("Cannot display " + urlHome);
    }

    jScrollPane =
        new JScrollPane(htmlPane,
                        JScrollPane.
                        VERTICAL_SCROLLBAR_ALWAYS,
                        JScrollPane.
                        HORIZONTAL_SCROLLBAR_ALWAYS);

    jScrollPane.setPreferredSize(new Dimension(1000, 800));
    getContentPane().add(jScrollPane);
    htmlPane.setContentType("text/html");
    htmlPane.setEditable(false);
    htmlPane.addHyperlinkListener(this);
  }

  public void hyperlinkUpdate(HyperlinkEvent evt)
  {
    if (evt.getEventType() ==
        HyperlinkEvent.EventType.ACTIVATED)
    {
      try
      {
        htmlPane.setPage(evt.getURL());
      }
      catch (IOException ex)
      {
        System.out.println("Cannot display " + evt.getURL());
      }
    }
  }

  public static void main(String[] args)
  {
    EventQueue.invokeLater(new Runnable()
    {
      public void run()
      {
        new GuiEx6();
      }
    });
  }
}
