// SettingsDialog.java

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

class SettingsDialog extends JDialog
{
  private class BtnActionAdapter implements ActionListener
  {
    private int btnNb;

    private BtnActionAdapter(int btnNb)
    {
      this.btnNb = btnNb;
    }

    public void actionPerformed(ActionEvent evt)
    {
      choice = btnNb;
    }
  }

  private JPanel contentPane = (JPanel)getContentPane();
  private JPanel panel = new JPanel();
  private JPanel borderPanel = new JPanel();

  private JRadioButton[] radioBtn = {new JRadioButton("Ramp"),
                                     new JRadioButton(
                                       "Rectangle"),
                                     new JRadioButton(
                                       "Triangle"),
                                     new JRadioButton(
                                       "Equal harmonics")};
  private ButtonGroup buttonGroup = new ButtonGroup();
  private JButton okBtn = new JButton("Ok");
  private JButton cancelBtn = new JButton("Cancel");
  private boolean isOk;
  private int choice;

  SettingsDialog(Frame owner)
  {
    super(owner, "Select", true); // Modal dialog
    init();
    pack();
    setLocationRelativeTo(owner); // Center to owner
  }

  private void init()
  {
    setResizable(false);
    contentPane.setLayout(new BorderLayout());
    contentPane.add(panel, BorderLayout.CENTER);
    panel.setLayout(null);
    panel.setPreferredSize(new Dimension(260, 280));

    for (int nb = 0; nb < radioBtn.length; nb++)
    {
      buttonGroup.add(radioBtn[nb]);
      radioBtn[nb].addActionListener(
        new BtnActionAdapter(nb));
    }

    radioBtn[0].setBounds(new Rectangle(70, 40, 130, 30));
    radioBtn[1].setBounds(new Rectangle(70, 75, 130, 30));
    radioBtn[2].setBounds(new Rectangle(70, 110, 130, 30));
    radioBtn[3].setBounds(new Rectangle(70, 145, 130, 30));
    panel.add(radioBtn[0]);
    panel.add(radioBtn[1]);
    panel.add(radioBtn[2]);
    panel.add(radioBtn[3]);

    borderPanel.setBorder(
      BorderFactory.createLineBorder(Color.black));
    borderPanel.setBounds(new Rectangle(40, 25, 180, 170));
    panel.add(borderPanel);

    okBtn.setBounds(new Rectangle(40, 220, 70, 25));
    cancelBtn.setBounds(new Rectangle(150, 220, 70, 25));
    panel.add(okBtn);
    panel.add(cancelBtn);

    contentPane.add(panel);

    okBtn.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        isOk = true;
        hide();
      }
    });

    cancelBtn.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {
        isOk = false;
        setVisible(false);
      }
    });
  }

  int getChoice()
  {
    return choice;
  }

  boolean show(int selection)
  {
    radioBtn[selection].setSelected(true);
    choice = selection;
    isOk = false;
    okBtn.requestFocus();
    setVisible(true); // Hang until dialog is hidden
    return isOk;
  }
}
