// DaytimeClient.java

import java.net.*;
import java.io.*;
import ch.aplu.util.Console;

public class DaytimeClient
{
  private static final String HOSTNAME = "localhost";
  private static final int PORT = 13;

  public DaytimeClient()
  {
    BufferedReader reader = null;
    Socket socket = null;
    String line;
    try
    {
      socket = new Socket(HOSTNAME, PORT);
      System.out.println("Connection established");
      socket.setSoTimeout(15000); // 15 sec

      reader = new BufferedReader(
        new InputStreamReader(socket.getInputStream()));

      while ((line = reader.readLine()) != null)
      {
        System.out.println(line);
      }
    }
    catch (IOException ex)
    {
      System.out.println("Error " + ex);
    }
    finally
    {
      try
      {
        if (reader != null)
          reader.close();
        if (socket != null)
          socket.close();
      }
      catch (IOException ex) {}
    }
  }

  public static void main(String args[])
  {
    Console.init();
    new DaytimeClient();
  }
}
