// DaytimeServer.java

import java.net.*;
import java.io.*;
import java.util.*;
import ch.aplu.util.Console;

public class DaytimeServer
{
  private static final int SERVICE_PORT = 13;
  private boolean isLazy = false;

  public DaytimeServer()
  {
    try
    {
      ServerSocket server = new ServerSocket(SERVICE_PORT);
      if (isLazy)
        System.out.print("Lazy ");
      else
        System.out.print("Quick ");
      System.out.println("daytime service started");

      while (true)
      {
        Socket client = server.accept();
        System.out.println("Received request on " +
                           new Date() + " from " +
                           client.getInetAddress() + ":" +
                           client.getPort());
        PrintWriter pr =
          new PrintWriter(client.getOutputStream());

        if (isLazy)
          Console.delay(10000); // lazy server
        Date now = new Date();
        pr.println("The current daytime is: " + now);
        pr.println("Goodbye");

        //        pr.flush();
        pr.close();
        client.close();
      }
    }
    catch (BindException ex)
    {
      System.err.println("Service already running on port " +
                         SERVICE_PORT);
    }
    catch (IOException ex)
    {
      System.err.println("Error " + ex);
    }
  }

  public static void main(String args[])
  {
    Console.init();
    new DaytimeServer();
  }
}
