// PortEnumerator.java

import javax.comm.*;
import java.util.Enumeration;
import ch.aplu.util.*;

public class PortEnumerator
{
  public PortEnumerator()
  {
    Enumeration portList;
    CommPortIdentifier portId;
    CommPort commPort = null;
    String portName;
    int portType;
    String portTypeText;

    portList = CommPortIdentifier.getPortIdentifiers();
    if (!portList.hasMoreElements())
    {
      System.err.print(
        "No ports found - " +
        "Make sure javax.comm.properties file is found");
    }

    while (portList.hasMoreElements())
    {
      portId = (CommPortIdentifier)portList.nextElement();
      {
        portName = portId.getName();
        portType = portId.getPortType();
        switch (portType)
        {
          case CommPortIdentifier.PORT_SERIAL :
            portTypeText = "serial";
            break;

          case CommPortIdentifier.PORT_PARALLEL :
            portTypeText = "parallel";
            break;

          default :
            portTypeText = "unkonwn";
            break;
        }
        System.out.println("\nPort found. Port name: " +
                           portName + " \nPort type: " +
                           portTypeText);

        if (!portTypeText.equals("unknown"))
        {
          try
          {
            System.out.print("Trying to open it...");
            if (portTypeText.equals("serial"))
              commPort = (SerialPort)portId.open("myport",
                                                 1000);
            if (portTypeText.equals("parallel"))
              commPort = (ParallelPort)portId.open("myport",
                                                   1000);
            System.out.println("Ok");

            // do something with the port
            try
            {
              System.out.print("Closing it now...");
              commPort.close();
              System.out.println("Ok");
            }
            catch (IllegalStateException ex)
            {
              System.out.println("failed\n" +
                                 ex.getMessage());
            }
          }
          catch (PortInUseException ex)
          {
            System.out.println("failed (port in use)\n" +
                               ex.getMessage());
          }
        }
      }
    }
  }

  public static void main(String args[])
  {
    Console.init();
    new PortEnumerator();
  }
}
