// SimpleTerminal.java
// Set portName, echo and crlf as appropriate

import java.io.*;
import javax.comm.*;
import ch.aplu.util.Console;
import java.awt.event.*;

public class SimpleTerminal extends Console
{
  private final String portName = "COM1";
  private final boolean echo = false;
  private final boolean crlf = true;

  public SimpleTerminal() throws IOException
  {
    InputStream is;
    OutputStream os;
    SerialPort port = null;
    char ch;
    int nbBytes;
    byte[] readBuffer = new byte[1000];

    System.out.print("Trying to open " + portName + "...");
    port = PortCreator.openPort(portName);

    if (port == null)
    {
      System.out.println("Failed");
      return;
    }
    System.out.println("Ok");

    is = port.getInputStream();
    os = port.getOutputStream();

    while (true)
    {
      delay(1);
      ch = getKey();
      if (ch != KeyEvent.CHAR_UNDEFINED)
      {
        if (ch == '\n')
        {
          if (echo)
            println();
          os.write('\r');
          if (crlf)
            os.write('\n');
        }
        else
        {
          if (echo)
            print(ch);
          os.write(ch);
        }
      }

      if (is.available() > 0)
      {
        nbBytes = is.read(readBuffer);
        print(new String(readBuffer, 0, nbBytes));
      }
    }
  }

  public static void main(String args[]) throws IOException
  {
    new SimpleTerminal();
  }
}
