// LptPortEx1.java

import ch.aplu.util.LptPort;

class LptPortEx1
{
  int baseAddress = 0x3BC;

  LptPortEx1()
  {
    System.loadLibrary("jlptport");
    System.out.print("Opening parallel port now... ");

    LptPort lpt1 = new LptPort();

    int rc = lpt1.open(baseAddress);
    if (rc == 0)
      System.out.println("ok");
    else
    {
      System.out.println("failed");
      return;
    }

    int outdata = 0x07;
    System.out.println("Write " + outdata + " to data port...");
    lpt1.writeData(outdata);

    System.out.println("Write it to control port...");
    lpt1.writeControl(outdata);

    int indata = lpt1.readData();
    System.out.println("Got from data port: " + indata);

    int status = lpt1.readStatus();
    System.out.println("Got from status port: " + status);

    lpt1.close();
    System.out.println("Parallel port closed");
  }

  public static void main(String[] args)
  {
    new LptPortEx1();
  }
}
