// JLPTPORT.C

#include "ch_aplu_util_LptPort.h"
#include <stdio.h>
#include <conio.h>
#include <windows.h>


/* Typedefs for functions in DLL */
typedef short _stdcall (*inpfuncPtr)(short portaddr);
typedef void _stdcall (*oupfuncPtr)(short portaddr, short data);

/* Global variables */
static HINSTANCE hLib = NULL;
static inpfuncPtr inp32 = NULL;
static oupfuncPtr oup32 = NULL;
static int isOpen = 0;
static int baseAddress;


JNIEXPORT jint JNICALL
Java_ch_aplu_util_LptPort_open(JNIEnv * env, jobject obj, jint val)
{
  /* Load the library */
   hLib = LoadLibrary("inpout32.dll");
   if (hLib == NULL) 
     return (jint)-1;

   /* Get address of the function */
   inp32 = (inpfuncPtr) GetProcAddress(hLib, "Inp32");
   if (inp32 == NULL) 
     return (jint)-1;

   oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");
   if (oup32 == NULL)
     return (jint)-1;

  baseAddress = (int)val;
  isOpen = 1;
  return (jint)0;
}


JNIEXPORT jboolean JNICALL 
Java_ch_aplu_util_LptPort_isOpen(JNIEnv * env, jobject obj)
{
  return (jboolean)isOpen;
}


JNIEXPORT jint JNICALL 
Java_ch_aplu_util_LptPort_writeData(JNIEnv * env, jobject obj, jint val)
{
  if (!isOpen)
    return (jint)-1;
  (oup32)(baseAddress, (short)val);
  return (jint)0;
}

JNIEXPORT jint JNICALL 
Java_ch_aplu_util_LptPort_writeControl(JNIEnv * env, jobject obj, jint val)
{
  if (!isOpen)
    return (jint)-1;
  (oup32)(baseAddress + 2, (short)val);
  return (jint)0;
}


JNIEXPORT jint JNICALL 
Java_ch_aplu_util_LptPort_readData(JNIEnv * env, jobject obj)
{
  short val;
  if (!isOpen)
    return (jint)-1;
  val = (inp32)(baseAddress);
  return (jint)(val & 0xFF);
}

JNIEXPORT jint JNICALL 
Java_ch_aplu_util_LptPort_readStatus(JNIEnv * env, jobject obj)
{
  short val;
  if (!isOpen)
    return (jint)-1;
  val = (inp32)(baseAddress + 1);
  return (jint)(val & 0xFF);
}

JNIEXPORT void JNICALL 
Java_ch_aplu_util_LptPort_close(JNIEnv * env, jobject obj)
{
  if (isOpen)
    FreeLibrary(hLib);
}

