// Farn.java

import java.awt.*;
import java.awt.image.*;

public class Farn extends Canvas
{
  private BufferedImage bi;
  private Graphics2D offG2D;
  private Color bkColor = Color.darkGray;
  private double x = 0, y = 0;
  private int width, height;
  private int nbPoints = 0;

  Farn(int width, int height)
  {
    this.width = width;
    this.height = height;
    bi = new BufferedImage(width, height,
                           BufferedImage.TYPE_INT_RGB);
    offG2D = bi.createGraphics();
    offG2D.setColor(bkColor);
    offG2D.fillRect(0, 0, width, height);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(width, height);
  }

  public void paint(Graphics g)
  {
    g.drawImage(bi, 0, 0, null);
  }

  private void f(double a, double b, double c, double d,
                 double e, double f, Color color, Graphics g)
  {
    double xnew = a * x + b * y + e;
    double ynew = c * x + d * y + f;
    x = xnew;
    y = ynew;
    int xPoint = (int)((x + 5) / 10.0 * width); // x = -5..5
    int yPoint = (int)((11 - y) / 12.0 * height); // y = 0..10

    // Draw on screen
    g.setColor(color);
    g.drawLine(xPoint, yPoint, xPoint, yPoint);

    // Draw in offscreen buffer
    offG2D.setColor(color);
    offG2D.drawLine(xPoint, yPoint, xPoint, yPoint);
  }

  public int getNbPoints()
  {
    return nbPoints;
  }

  public void update(Graphics g)
  {
    nbPoints++;
    double r = Math.random();
    if (r < 0.01) // Stiel
    {
      f(0, 0, 0, 0.16, 0, 0, Color.green, g);
      return;
    }
    if (r < 0.86) // Obere Blaetter
    {
      f(0.85, -0.04, +0.04, 0.85, 0, 1.60, Color.green, g);
      return;
    }
    if (r < 0.93) // Linkes Blatt
    {
      f(0.20, -0.26, 0.23, 0.22, 0, 1.60, Color.red, g);
      return;
    }
    if (r > 0.93) // Rechtes Blatt
    {
      f(-0.15, 0.28, 0.26, 0.24, 0, 1.44, Color.orange, g);
      return;
    }
  }
}
