// JBufferedMan.java

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class JBufferedMan extends JPanel
{
  private Image image;
  private BufferedImage bi;
  private Graphics2D offG2D;
  private int xPos, yPos;

  public JBufferedMan(String imagePath, int x, int y)
  {
    image = new ImageIcon(imagePath).getImage();
    xPos = x;
    yPos = y;
    setPreferredSize(new Dimension(400, 400));
    setBackground(Color.cyan);
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    Dimension d = getSize();
    Graphics2D g2D = (Graphics2D)g;

    // Create new offscreen buffer if necessary
    checkOffScreenBuffer();

    // Clear offscreen buffer
    offG2D.setColor(getBackground());
    offG2D.fillRect(0, 0, d.width, d.height);

    // Draw in offscreen buffer
    offG2D.drawImage(image, xPos, yPos, null);

    // Put offscreen buffer on screen
    g2D.drawImage(bi, 0, 0, null);
  }

  private void checkOffScreenBuffer()
  {
    Dimension d = getSize();
    if (bi == null // no buffer yet

    // Size changed due to resizing
    || bi.getWidth(null) != d.width || bi.getHeight(null)
            != d.height)
    {
      bi = new BufferedImage(d.width, d.height,
                             BufferedImage.TYPE_INT_RGB);
      offG2D = bi.createGraphics();
    }
  }

  public void setPos(int x, int y)
  {
    xPos = x;
    yPos = y;
  }
}
