// JSkyline.java

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

public class JSkyline extends JPanel
{
  private GradientPaint blueToBlack = new GradientPaint(0, 0,
      Color.blue,
      0, 40,
      Color.black);
  private Point2D.Float[] corners_1 =
      {
      new Point2D.Float(20, 0),
      new Point2D.Float(40, 40),
      new Point2D.Float(0, 40)};
  private PrettyTriangle pt_1 =
    new PrettyTriangle(corners_1, blueToBlack);

  private GradientPaint blackToBlue = new GradientPaint(0, 20,
      Color.black,
      0, 40,
      Color.blue);
  private Point2D.Float[] corners_2 =
      {
      new Point2D.Float(10, 20),
      new Point2D.Float(30, 20),
      new Point2D.Float(20, 40)};
  private PrettyTriangle pt_2 =
    new PrettyTriangle(corners_2, blackToBlue);

  private int nb = 0;

  public JSkyline()
  {
    setPreferredSize(new Dimension(400, 400));
  }

  public void paintComponent(Graphics g)
  {
    super.paintComponent(g);
    System.out.println("Number of calls to paintComponent(): " + nb++);
    Graphics2D g2D = (Graphics2D)g;
    Dimension d = getSize();
    int width = d.width;
    int height = d.height;
    drawBackground(g2D, width, height);
    g2D.scale(10.0 * width / 400, 10.0 * height / 400);
    pt_1.show(g2D);
    pt_2.show(g2D);
  }

  private void drawBackground(Graphics2D g2D, int width,
                              int height)
  {
    g2D.setColor(Color.blue);
    g2D.fillRect(0, 0, width, height);
  }
}
