// TurtleApplet1a.java
// main() and initStandalone() for testing as application

import javax.swing.*;
import ch.aplu.turtle.*;

public class TurtleApplet1a extends JApplet implements Runnable
{
  private boolean isActive = true;
  private Turtle t;

  public void init()
  {
    TurtleArea ta = new TurtleArea(this);
    t = new Turtle(ta);
  }

  public void start()
  {
    new Thread(this).start();
  }

  public void stop()
  {
    isActive = false; // Causes thread to stop
  }

  public void run()
  {
    t.penUp();
    t.back(100);
    t.showTurtle();
    t.penDown();
    while (isActive)
    {
      baum(128);
      t.sleep(500);
      t.clear();
    }
  }

  private void baum(int s)
  {
    if (s < 8 || isActive == false)
      return;
    t.forward(s);
    t.left(45);
    baum(s / 2);
    t.right(90);
    baum(s / 2);
    t.left(45);
    t.back(s);
  }


  private void initStandalone()
  {
    init();
    JFrame f = new JFrame();
    f.setContentPane(getContentPane());
    f.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    f.pack();
    f.setResizable(false);
    f.setVisible(true);
    start();
  }

  public static void main(String[] args)
  {
    TurtleApplet1a ta = new TurtleApplet1a();
    ta.initStandalone();
  }
}